=== deps/rabbitmq_jms_topic_exchange/Makefile ===
PROJECT = rabbitmq_jms_topic_exchange

DEPS = amqp_client
TEST_DEPS += rabbit

DEP_PLUGINS = rabbit_common/mk/rabbitmq-plugin.mk

# FIXME: Use erlang.mk patched for RabbitMQ, while waiting for PRs to be
# reviewed and merged.

ERLANG_MK_REPO = https://github.com/rabbitmq/erlang.mk.git
ERLANG_MK_COMMIT = rabbitmq-tmp

include rabbitmq-components.mk
include erlang.mk
