=== control ===
Source: nginx
Section: httpd
Priority: optional
Maintainer: Sergey Budnevitch <sb@nginx.com>
Build-Depends: debhelper (>= 7.0.50~),
               libgd2-xpm-dev,
               libgeoip-dev,
               libpcre3-dev,
               libperl-dev,
               libssl-dev (>= 0.9.7),
               libxslt1-dev,
               lsb-release,
               zlib1g-dev
Standards-Version: 3.9.1
Homepage: http://nginx.org

Package: nginx
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, lsb-base, adduser
Provides: httpd
Description: high performance web server
 nginx [engine x] is an HTTP and reverse proxy server, as well as
 a mail proxy server.

Package: nginx-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, nginx (= ${source:Version})
Description: nginx debug symbols
 This package contains the debugging symbols for nginx.

Package: nginx-module-xslt
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, nginx (= ${source:Version})
Description: xslt module
 This package contains dynamic xslt module for nginx.

Package: nginx-module-image-filter
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, nginx (= ${source:Version})
Description: image filter module
 This package contains dynamic image filter module for nginx.

Package: nginx-module-geoip
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, nginx (= ${source:Version})
Description: geoip module
 This package contains dynamic geoip module for nginx.

Package: nginx-module-perl
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, nginx (= ${source:Version})
Description: perl module
 This package contains dynamic perl module for nginx.

Package: nginx-module-njs
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, nginx (= ${source:Version})
Description: nJScript module
 This package contains dynamic nJScript module for nginx.
